class MyThread extends Thread { 
  int count;  
 
  MyThread(String name) { 
    super(name);
    count = 0; 
  } 
 
    public void run() { // vstupni bod vlakna
    System.out.println(getName() + " startuje."); 
    try {  
      do { 
        Thread.sleep(500); 
        System.out.println("Ve vlaknu " + getName() + 
                           ", citac je " + count); 
        count++; 
      } while(count < 5); 
    } 
    catch(InterruptedException exc) { 
      System.out.println(getName() + " prerusene."); 
    } 
    System.out.println(getName() + " ukoncene."); 
  } 
} 
 
class Vlakno { 
  public static void main(String args[]) { 
    System.out.println("Hlavni vlakno startuje"); 
 
    // Nejdve konstruujeme MyThread objekt. 
    MyThread mt = new MyThread("potomek"); 
 
    // Az pak startujeme vypocet vlakna 
    mt.start(); 
 
    do { 
      System.out.print("."); 
      try { 
        Thread.sleep(100); 
      } 
      catch(InterruptedException exc) { 
        System.out.println("Hlavni vlakno prerusene."); 
      } 
    } while (mt.count != 5); 
 
    System.out.println("Konci hlavni vlakno"); 
  } 
} 
