import java.io.IOException;

//Pr.92Vlakna 	Skupiny vlaken a demoni
public class Demon implements Runnable 
{
    public static void main(String[] args)
    {
	mainThread = Thread.currentThread();
        System.out.println("Hlavni zacina, skupina=" + mainThread.getThreadGroup());
        Demon d = new Demon();
        d.init();
    }

    private static Thread mainThread;

    public void init()
    {
        try
        {
            // Vytvori novou ThreadGroup rodicGroup a jejiho potomka
            ThreadGroup rodicGroup =
                new ThreadGroup("rodic ThreadGroup");

            ThreadGroup potomekGroup =
                new ThreadGroup(rodicGroup, "potomek ThreadGroup");

            // Vytvori a odstartuje druhe vlakno
            Thread vlakno2 = new Thread(rodicGroup, this);
            System.out.println("Startuje " + vlakno2.getName() + "...");
            vlakno2.start();
            
            // Vytvori a odstartuje treti vlakno
            Thread vlakno3 = new Thread(potomekGroup, this);
            System.out.println("Startuje " + vlakno3.getName() + "...");
            vlakno3.setDaemon(true);
            vlakno3.start();
            
            // Vypise pocet aktivnich vlaken ve skupine rodicGroup
            System.out.println("Aktivnich vlaken ve skupine " +rodicGroup.getName() + " = " +
                rodicGroup.activeCount());//////////////////////////////////

            System.out.println("Hlavni - mam teda skoncit (ENTER) ?");
	    System.in.read();
	    System.out.println("Enter.....");


            System.out.println("Hlavni konci");
	    return;
        }
	catch (IOException e)
	{
	    System.out.println(e);
	}
    }

    // Implements Runnable.run()
    public void run()
    {
	long max = 10;
	if (Thread.currentThread().getName().equals("Thread-1"))
		max *= 2; 
        for (int i = 0; i < max; i++)
        {
	    try {
	        System.out.println(Thread.currentThread().getName() + ": " + i);
	        Thread.sleep(500);
	    }
            catch (InterruptedException ex)
            {
                System.out.println(ex.toString());
            }
            counter++;
        }
        System.out.println("Hlavni alive:" + mainThread.isAlive());

        System.out.println(Thread.currentThread().getName() + "skoncilo vypocet.");
    }

    private int counter = 0;
}
