   import java.util.concurrent.*;   
   
   public class Soucet {
     private static int matrix[][] = {
       {1, 1, 1, 1, 1},
       {2, 2, 2, 2, 2},
       {3, 3, 3, 3, 3},
       {4, 4, 4, 4, 4},
       {5, 5, 5, 5, 5}
     };
     private static int results[];   
   
     private static class Summer extends Thread {
       int row;
       CyclicBarrier barrier;
       Summer(CyclicBarrier barrier, int row) { 
         this.barrier = barrier;
         this.row = row;
       }
       public void run() {
         int columns = matrix[row].length;
         int sum = 0;
         for (int i=0; i<columns; i++) {
           sum += matrix[row][i];
         }
         results[row] = sum;
         System.out.println(
            "Vysledek pro radek " + row + " je : " + sum);
         try {
           barrier.await();
         } catch (InterruptedException ex) {
           ex.printStackTrace();
         } catch (BrokenBarrierException ex) {
           ex.printStackTrace();
         }
       }
     }
        
     public static void main(String args[]) {
       final int rows = matrix.length; 
       results = new int[rows];
       Runnable merger = new Runnable() {
         public void run() {
           int sum = 0;
           for (int i=0; i<rows; i++) {
             sum += results[i];
           }
           System.out.println("Celkovy vysledek je " + sum);
         }
       };
       CyclicBarrier barrier = new CyclicBarrier(rows, merger);
       for (int i=0; i<rows; i++) {
         new Summer(barrier, i).start();
       }
       System.out.println("Cekani kdy nen k tisku zatim zadny soucet");
     }
   }

